unit MainUnit;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.Objects,
  FMX.Layouts, System.IOUtils, System.UIConsts, IniFiles,
  {$IFDEF MSWINDOWS}
  FMX.Platform.Win,
  {$ENDIF}
  {$IFDEF ANDROID}
  FMX.VirtualKeyboard, FMX.DialogService,
  {$ENDIF}
  System.Net.HttpClient, System.Net.HttpClientComponent, System.Net.URLClient,
  System.DateUtils, System.ImageList, FMX.ImgList, System.Generics.Collections,
  System.StrUtils, System.JSON, FMX.Edit, FMX.EditBox, FMX.SpinBox, FMX.Utils,
  System.Rtti, FMX.Grid.Style, FMX.NumberBox, FMX.Grid, FMX.ScrollBox,
  FMX.ComboEdit, System.Math.Vectors, System.Math, FMX.Controls.Presentation,
  FMX.StdCtrls, FMX.Clipboard, FMX.Surfaces, FMX.Platform, System.SyncObjs,
  FMX.ListBox, FMX.TabControl, FMX.ListView.Types, System.Generics.Defaults,
  FMX.ListView.Appearances, FMX.ListView.Adapters.Base, FMX.ListView,
  FMX.Memo.Types, FMX.Memo,
  KyoshinUnit, CommonUnit, FMX.MultiView, FMX.Effects, FMX.Gestures;
type
  TAreaRange = (arNone, arMain, arFrame, arBorder);

  TMainForm = class(TForm)
    FormBase: TLayout;
    TopBase: TRectangle;
    ImageBase: TLayout;
    BottomBase: TLayout;
    TabControl1: TTabControl;
    TabItem1: TTabItem;
    ImageList1: TImageList;
    StyleBook1: TStyleBook;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    PaintBox1: TPaintBox;
    ColorScaleBase: TLayout;
    ScaleImage: TImage;
    Rectangle1: TRectangle;
    Label3: TLabel;
    Layout6: TLayout;
    SpinBox2: TSpinBox;
    Label2: TLabel;
    Label1: TLabel;
    SpinBox1: TSpinBox;
    SpeedButton1: TSpeedButton;
    TabItem2: TTabItem;
    TabItem3: TTabItem;
    TabItem4: TTabItem;
    VertScrollBox1: TVertScrollBox;
    BottomBaseBack: TRectangle;
    BottomHeader: TLayout;
    Layout2: TLayout;
    Layout10: TLayout;
    Layout1: TLayout;
    Rectangle3: TRectangle;
    VertScrollBox2: TVertScrollBox;
    VertScrollBox3: TVertScrollBox;
    Rectangle11: TRectangle;
    Label24: TLabel;
    Layout18: TLayout;
    SpinBox3: TSpinBox;
    Label13: TLabel;
    Layout19: TLayout;
    Label21: TLabel;
    SpinBox4: TSpinBox;
    Rectangle12: TRectangle;
    Label59: TLabel;
    Switch2: TSwitch;
    Layout20: TLayout;
    Label27: TLabel;
    SpinBox5: TSpinBox;
    Layout24: TLayout;
    Label28: TLabel;
    SpinBox6: TSpinBox;
    VertScrollBox5: TVertScrollBox;
    GridPanelLayout10: TGridPanelLayout;
    Layout45: TLayout;
    Edit21: TEdit;
    Label60: TLabel;
    Layout46: TLayout;
    Edit22: TEdit;
    Label61: TLabel;
    Layout47: TLayout;
    Edit23: TEdit;
    Label62: TLabel;
    GridPanelLayout11: TGridPanelLayout;
    Layout13: TLayout;
    Edit18: TEdit;
    Label58: TLabel;
    Layout48: TLayout;
    Edit17: TEdit;
    Label57: TLabel;
    GridPanelLayout12: TGridPanelLayout;
    Layout49: TLayout;
    Edit20: TEdit;
    Label63: TLabel;
    Layout50: TLayout;
    Edit24: TEdit;
    Label64: TLabel;
    GridPanelLayout8: TGridPanelLayout;
    Layout4: TLayout;
    Edit9: TEdit;
    Label17: TLabel;
    Layout41: TLayout;
    Edit7: TEdit;
    Label15: TLabel;
    Layout42: TLayout;
    Edit8: TEdit;
    Label16: TLabel;
    GridPanelLayout9: TGridPanelLayout;
    Layout12: TLayout;
    Edit10: TEdit;
    Label19: TLabel;
    Layout43: TLayout;
    Edit11: TEdit;
    Label20: TLabel;
    Layout44: TLayout;
    Edit13: TEdit;
    Label25: TLabel;
    Rectangle13: TRectangle;
    Label56: TLabel;
    Rectangle2: TRectangle;
    Label14: TLabel;
    Rectangle8: TRectangle;
    Label18: TLabel;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpeedButton9: TSpeedButton;
    TabItem5: TTabItem;
    VertScrollBox4: TVertScrollBox;
    GridPanelLayout4: TGridPanelLayout;
    Layout30: TLayout;
    SpinBox7: TSpinBox;
    Label32: TLabel;
    Layout31: TLayout;
    SpinBox8: TSpinBox;
    Label33: TLabel;
    GridPanelLayout6: TGridPanelLayout;
    Layout27: TLayout;
    Label37: TLabel;
    NumberBox5: TNumberBox;
    Label50: TLabel;
    Layout29: TLayout;
    Label38: TLabel;
    NumberBox6: TNumberBox;
    Layout28: TLayout;
    Button4: TButton;
    Layout34: TLayout;
    Label39: TLabel;
    Label40: TLabel;
    NumberBox1: TNumberBox;
    Label46: TLabel;
    NumberBox2: TNumberBox;
    Label47: TLabel;
    Layout35: TLayout;
    Label41: TLabel;
    Label42: TLabel;
    Button7: TButton;
    NumberBox3: TNumberBox;
    Label48: TLabel;
    Label49: TLabel;
    NumberBox4: TNumberBox;
    Layout36: TLayout;
    Label43: TLabel;
    Label44: TLabel;
    Button5: TButton;
    NumberBox7: TNumberBox;
    Layout37: TLayout;
    Button6: TButton;
    Layout39: TLayout;
    NumberBox8: TNumberBox;
    NumberBox9: TNumberBox;
    Button3: TButton;
    Edit12: TEdit;
    Label51: TLabel;
    Layout40: TLayout;
    Label52: TLabel;
    NumberBox10: TNumberBox;
    Label53: TLabel;
    Label54: TLabel;
    NumberBox11: TNumberBox;
    Button9: TButton;
    Edit16: TEdit;
    Rectangle10: TRectangle;
    Label55: TLabel;
    Rectangle14: TRectangle;
    Label31: TLabel;
    Rectangle15: TRectangle;
    Label36: TLabel;
    Rectangle16: TRectangle;
    Layout38: TLayout;
    Label45: TLabel;
    Edit19: TEdit;
    Rectangle17: TRectangle;
    GridPanelLayout5: TGridPanelLayout;
    Layout32: TLayout;
    Label34: TLabel;
    Edit14: TEdit;
    Layout33: TLayout;
    Label35: TLabel;
    Edit15: TEdit;
    Rectangle9: TRectangle;
    Label11: TLabel;
    Rectangle18: TRectangle;
    Rectangle19: TRectangle;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    Label4: TLabel;
    MainLoop: TTimer;
    ShindoListBase: TLayout;
    Rectangle20: TRectangle;
    Label22: TLabel;
    ListView1: TListView;
    Popup1: TPopup;
    ListBox1: TListBox;
    ListBoxItem1: TListBoxItem;
    ListBoxItem2: TListBoxItem;
    ListBoxItem3: TListBoxItem;
    ListBoxItem4: TListBoxItem;
    Layout8: TLayout;
    Label65: TLabel;
    Edit27: TEdit;
    GestureManager1: TGestureManager;
    Layout26: TLayout;
    Label66: TLabel;
    Edit29: TEdit;
    Layout51: TLayout;
    Label67: TLabel;
    Edit30: TEdit;
    Rectangle22: TRectangle;
    Label68: TLabel;
    Layout52: TLayout;
    Label69: TLabel;
    Edit31: TEdit;
    Layout53: TLayout;
    Label70: TLabel;
    Switch3: TSwitch;
    Rectangle25: TRectangle;
    Label71: TLabel;
    Layout54: TLayout;
    Label72: TLabel;
    Edit32: TEdit;
    Label73: TLabel;
    LogoImageBase: TLayout;
    LogoImage: TImage;
    Layout14: TLayout;
    Label30: TLabel;
    SpinBox9: TSpinBox;
    Layout25: TLayout;
    Label74: TLabel;
    Switch1: TSwitch;
    Layout55: TLayout;
    Label75: TLabel;
    SpinBox10: TSpinBox;
    ShindoLayout: TLayout;
    Layout57: TLayout;
    Label77: TLabel;
    Layout58: TLayout;
    Label78: TLabel;
    PSLayout: TLayout;
    Layout56: TLayout;
    Rectangle27: TRectangle;
    Label79: TLabel;
    GridPanelLayout3: TGridPanelLayout;
    Layout21: TLayout;
    Edit6: TEdit;
    Label99: TLabel;
    Layout22: TLayout;
    Edit4: TEdit;
    Label9: TLabel;
    Layout23: TLayout;
    Edit5: TEdit;
    Label10: TLabel;
    Layout59: TLayout;
    Label7: TLabel;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Rectangle4: TRectangle;
    Rectangle5: TRectangle;
    Edit26: TEdit;
    Layout5: TLayout;
    Label5: TLabel;
    Image4: TImage;
    Rectangle6: TRectangle;
    BottomBox: TLayout;
    SpeedButton7: TSpeedButton;
    TabItem6: TTabItem;
    StringGrid1: TStringGrid;
    StringColumn1: TStringColumn;
    StringColumn2: TStringColumn;
    SpeedButton10: TSpeedButton;
    Label6: TLabel;
    Layout7: TLayout;
    Label8: TLabel;
    Switch4: TSwitch;
    Label23: TLabel;
    Label26: TLabel;
    Label29: TLabel;
    Glyph1: TGlyph;
    Glyph2: TGlyph;
    Glyph3: TGlyph;
    Rectangle7: TRectangle;
    Label80: TLabel;
    Layout9: TLayout;
    Label81: TLabel;
    Switch5: TSwitch;
    GridPanelLayout1: TGridPanelLayout;
    Label82: TLabel;
    RadioButton2: TRadioButton;
    RadioButton1: TRadioButton;
    RadioButton3: TRadioButton;
    Rectangle21: TRectangle;
    Image5: TImage;
    Rectangle24: TRectangle;
    Label83: TLabel;
    Rectangle28: TRectangle;
    Label84: TLabel;
    GridPanelLayout2: TGridPanelLayout;
    Layout11: TLayout;
    Label85: TLabel;
    Glyph4: TGlyph;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    Layout3: TLayout;
    Edit25: TEdit;
    Label12: TLabel;
    Rectangle23: TRectangle;
    Button1: TButton;
    procedure SpeedButton2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject; Canvas: TCanvas);
    procedure FormShow(Sender: TObject);
    procedure TopBaseMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single);
    procedure TabButtonClick(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure BottomBoxResize(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Switch2Switch(Sender: TObject);
    procedure MainLoopTimer(Sender: TObject);
    procedure SpinBox3Change(Sender: TObject);
    procedure SpinBox4Change(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure ScreenShotMenuClick(Sender: TObject);
    procedure StringGrid1DrawColumnCell(Sender: TObject; const Canvas: TCanvas;
      const Column: TColumn; const Bounds: TRectF; const Row: Integer;
      const Value: TValue; const State: TGridDrawStates);
    procedure Button4Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure PaintBox1Click(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single);
    procedure Button3Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Layout1Gesture(Sender: TObject;
      const EventInfo: TGestureEventInfo; var Handled: Boolean);
    procedure StringGrid1DrawColumnHeader(Sender: TObject;
      const Canvas: TCanvas; const Column: TColumn; const Bounds: TRectF);
    procedure SpeedButton4MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpinBox9Change(Sender: TObject);
    procedure Switch1Switch(Sender: TObject);
    procedure SpinBox10Change(Sender: TObject);
    procedure SpinBoxMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; var Handled: Boolean);
    procedure Button1Click(Sender: TObject);
  private
    { private 錾 }
    FMainBitmap: TBitmap;
    FFramedBitmap: TBitmap;
    FMapBitmap: TBitmap;
    FMonitorBitmap: TBitmap;
    FWavesBitmap: TBitmap;
    FInfoBitmap: TBitmap;

    FJmaScale: TBitmap;
    FJmaScaleGrad: TBitmap;
    FKyoshinScale: TBitmap;

    FMapBitmapReady: boolean;
    FInfoBitmapEnabled: boolean;

    FShiftState: TShiftState;
    FMousePos: TPoint;
    FSaveBitmap: boolean;
    FEqID: string;
    FLastScreenshot: TDateTime;
    FEEWState: boolean;

    FLastDrawTime: TDateTime;
    FLastListShindoTime: TDateTime;

    FEEWAccess: TEEWAccess;
    FKyoshinAccess: TKyoshinAccess;
    FEstIntAccess: TEstIntAccess;
    FPSWavesAccess: TPSWavesAccess;

    FBottomBaseExpanded: boolean;
    {$IFDEF ANDROID}
    procedure FormKeyUp(Sender: TObject; var Key: Word; var KeyChar: Char;
      Shift: TShiftState);
    {$ENDIF}
    procedure SetKyoshinInfoPanel;
    procedure ChangeFontSizeOfCombo(ComboBox: TComboBox);
    procedure OnApplicationException(Sender: TObject; E: Exception);

    procedure LoadIniFile;
    procedure SaveIniFile;

    procedure CreateMap;                       // n}쐬
    procedure DrawCityOnMap(City: string; SList: TStringList);   // n}ɒn`
    procedure InitGrid;                        // EEWp̃Xg
    procedure SetNearestSpots;                 // ݒn̋ߖTϑ_̎擾
    procedure SetUIOnImageBase;                // eLayouẗʒuZbg
    procedure UpDateMainImage;                 // UIi摜j̍XV
    procedure SetKyoshinTime;                  // ̋kj^̃ANZXԂ̃Zbg
    procedure UpdateEEWItems(Rec: PEEWRec);    // EEWڂ̍XV
    procedure ScreenShot(Filename: string; Base: TLayout);    // XN[Vbg
    procedure DrawSPWave(Rec: PPsWavesInfo);   // PgSg̕`
    procedure SetShindoScale(Image: TImage; Scale: integer);                      // ݒɊÂĐkxXP[J[`
    function GetShindoColor(AScale: integer; AColor: TAlphaColor): TAlphaColor;   // ݒɊÂĐkxF擾
    procedure MakePSWavesImage(Rec: PPsWavesInfo);
    {$IFDEF MSWINDOWS}
    procedure Layout1Click(Sender: TObject);
    {$ENDIF}
  public
    { public 錾 }
    // e[JXbhĂяo
    procedure UpdateEEWDetails(Rec: PEEWRec);  // EEWڍׂ̍XV
    procedure ResetEEWDetails;                 // EEW̏IEEW\ڂZbg
    procedure UpdateKyoshinSpots(List: TList; DateTime: TDateTime; AKyoshinIndex: TKyoshinIndex);   // kj^ϑ_̕`
    procedure UpdateShindoList(List: TList; Count: integer; AScale: integer; AColor: TAlphaColor);  // u݂̐kxv̍XV
    procedure KyoshinReacted(List: TList<TRect>);                                                   // Ăϑ_͈
    procedure UpdateEstShindo(AScale: integer; AColor: TAlphaColor);
    procedure UpdatePSWaves(Rec: PPsWavesInfo);                                                     // \zkx̍XV
  end;                                                                                              // PgSg̍XV

var
  MainForm: TMainForm;

  // O[oϐ́u0vunil(null)vւ͕̏svKIɁBBB

  AppClosing: boolean = false;

  // EEWiً}nkj[hǂ
  EEWState: boolean = false;
  MapDrawRect: TMapDrawRect = TMapDrawRect.mrRightTop;      // ݂̒n}\͈ uEEEEEv
  DisplayedMapRect: TRect;                  // gn}̒́A\̋`
  SpotList: TList = nil;           // ϑ_Xg

  // ݒn̍ŋߊϑ_SpotListCfbNX
  NearestSpots: array[0..3] of TNearestSpot;
  // Eg̃}XNf[^
  MaskArray: array[0..351, 0..399] of Byte;

  // ݒp
  CurrentPointF: TPointF = (X:139.69; Y:35.7);   // ݒn Vh
  CurrentPoint: TPoint = (X:349; Y:259);

  MinKyoshinScale: integer = 20; // Cn}Ɋϑ_`悷ŏXP[l
  MinShindoScale: integer = 35;  // u݂̐kxvXɕ\ŏXP[l 30 = kx 0.0,   35 = kx 0.5

  // ŐVEEW̕ۑ
  EEW_Rec: TEEWRec;

  // debug
  IsDebug: boolean = false;

implementation

const
  // k̈ʒu͈̔ >> n}\͈ uEEEEEvɑΉ
  EpicenterRect_0: TRectF = (Left:127; Top:37.7; Right:133.3; Bottom:48); // TMapDrawRect.mrLeftTop
  EpicenterRect_2: TRectF = (Left:118; Top:20; Right:135; Bottom:32.7);   // TMapDrawRect.mrLeftBottom
  EpicenterRect_3: TRectF = (Left:135; Top:20; Right:160; Bottom:32.7);   // TMapDrawRect.mrRightBottom
  // ȊO                                                                TMapDrawRect.mrRightTopi{ʒuj


{$R *.fmx}

procedure MakeMaskArray;
begin
  var Stream := LoadStreamFromResource('MaskArray');
  if Stream <> nil then begin
    try
      for var Y := 0 to 399 do begin
        for var X := 0 to 351 do
          Stream.Read(MaskArray[X, Y], 1);
      end;
    finally
      Stream.Free;
    end;
  end;
end;

// RGBŋߖT_T荂ɍsȂ߂̃J[ubN̏
procedure CreateColorBlock;
var
  R, G, B: integer;
  SList: TStringList;
  Array0, Array1, Array2: TStringDynArray;
begin
  try
    // 
    for R := 0 to 7 do
      for G := 0 to 7 do
        for B := 0 to 7 do
          ColorBlockArray[R, G, B] := nil;

    // \[X烍[h
    SList := TStringList.Create;
    try
      SList.Text := LoadTextFromResource('ColorBlock');
      for var Text in SList do begin
        Array0 := SplitString(Text, '=');
        if Length(Array0) = 2 then begin
          Array1 := SplitString(Array0[0], ',');
          R := Array1[0].ToInteger;
          G := Array1[1].ToInteger;
          B := Array1[2].ToInteger;
          ColorBlockArray[R, G, B] := TList<Integer>.Create;
          Array2 := SplitString(Array0[1], ' ');
          for var v in Array2 do
            ColorBlockArray[R, G, B].Add(v.ToInteger);
        end;
      end;
    finally
      SList.Free;
    end;
  except
    on e: exception do
      AddToLog('CreateColorBlock', e.Message);
  end;
end;


// kj^̕ʘgiEj̈ʒuɈړ
procedure MoveFrame(SrcBitmap, DestBitmap: TBitmap; BackColor: TAlphaColor; IncludeBorder: boolean = false);
var
  FrameBitmap: TBitmap;
  DestMainRect, SrcRect, DestRect: TRect;
  SrcData, DestData: TBitmapData;
  SrcLine, DestLine: PAlphaColorArray;
  X, Y: integer;
  AColor: TAlphaColor;
begin
  DestMainRect := TRect.Create(Point(Ex_MapSize.cx-352, 0), 352, 400);
  SrcRect := TRect.Create(Point(0, 41), 172, 167);
  DestRect := TRect.Create(Point(0, 390), 172, 167);

  FrameBitmap := TBitmap.Create(DestRect.Width, DestRect.Height);
  try
    try
      FrameBitmap.Clear(0);
      // copy Frame
      if SrcBitmap.Map(TMapAccess.ReadWrite, SrcData) and FrameBitmap.Map(TMapAccess.Write, DestData) then begin
        try
          for Y := 35 to 220 do begin    // 41 .. 207
            SrcLine := SrcData.GetScanline(Y);
            DestLine := DestData.GetScanline(Y - 41);
            for X := 0 to 180 do begin  // 0 .. 171
              AColor := SrcLine^[X];
              if IncludeBorder then begin
                if MaskArray[X, Y] >= Byte(TAreaRange.arFrame) then begin  // ʘg + {[_[
                  DestLine^[X] := AColor;    // ړɏ
                  SrcLine^[X] := BackColor;  // ړɔwiF
                end;
              end else begin
                if MaskArray[X, Y] = Byte(TAreaRange.arFrame) then begin
                  DestLine^[X] := AColor;
                  SrcLine^[X] := BackColor;
                end else if MaskArray[X, Y] = Byte(TAreaRange.arBorder) then // {[_[
                  SrcLine^[X] := BackColor;
              end;
            end;
          end;
        finally
          SrcBitmap.UnMap(SrcData);
          FrameBitmap.UnMap(DestData)
        end;
      end;

      // Copy Main
      if DestBitmap.Canvas.BeginScene then begin
        try
          DestBitmap.Canvas.Clear(BackColor);
          DestBitmap.Canvas.DrawBitmap(SrcBitmap, SrcBitmap.Bounds, DestMainRect, 1.0);
          DestBitmap.Canvas.DrawBitmap(FrameBitmap, FrameBitmap.Bounds, DestRect, 1.0);
        finally
          DestBitmap.Canvas.EndScene;
        end;
      end;
    except
      on e: exception do
        AddToLog('MoveFrame', e.Message);
    end;
  finally
    FrameBitmap.Free;
  end;
end;

// 
procedure InitNow;
begin
  try
    // Op̃L[̍쐬
    LogQueue := TThreadList.Create;

    // n}̍Wϊp̃p[^̍쐬
    SetMapParams;

    // J[e[uubNXg
    CreateColorBlock;

    // ANZXXbh̍쐬
    for var i := Low(HttpAccesses) to High(HttpAccesses) do begin
      HttpAccesses[i] := THTTPAccess.Create;
      HttpAccesses[i].Start;
    end;
    // vL[̍쐬
    RequestQueue := TThreadList.Create;
    // L[̍쐬
    for var i := Low(ResponceQueues) to High(ResponceQueues) do
      ResponceQueues[i] := TThreadList.Create;

    // NTPXbh̍쐬
    NTPClient := TNTPClient.Create;
    NTPClient.Start;

    // c[ŎgpȈՑ\̃[h
    LoadTravelTimeTable;

  except
    on e: exception do
      AddToLog('InitNow', e.Message);
  end;
end;

// 
procedure FinalNow;
var
  List: TList;
begin
  try
    // NTPXbh̉
    NTPClient.Free;

    // ANZXXbh̉
    for var i := Low(HttpAccesses) to High(HttpAccesses) do
      HttpAccesses[i].Free;
    // vL[̉
    List := RequestQueue.LockList;
    if Assigned(List) and (List.Count > 0) then
      for var Rec: PRequestRec in List do
        if Rec <> nil then
          Dispose(Rec);
    RequestQueue.UnlockList;
    FreeAndNil(RequestQueue);
    // L[̉
    for var i := Low(ResponceQueues) to High(ResponceQueues) do begin
      List := ResponceQueues[i].LockList;
      if Assigned(List) and (List.Count > 0) then
        for var Rec: PResponseRec in List do
          if Rec <> nil then begin
            if Rec.Stream <> nil then
              Rec.Stream.Free;
            Dispose(Rec);
          end;
      ResponceQueues[i].UnlockList;
      FreeAndNil(ResponceQueues[i]);
    end;
    // OL[̉
    List := LogQueue.LockList;
    if Assigned(List) and (List.Count > 0) then
      for var Rec: PLogRec in List do
        if Rec <> nil then
          Dispose(Rec);
    LogQueue.UnlockList;
    FreeAndNil(LogQueue);

    // J[e[ũubNXgNA
    for var R := 0 to 7 do
      for var G := 0 to 7 do
        for var B := 0 to 7 do
          if ColorBlockArray[R, G, B] <> nil then
            ColorBlockArray[R, G, B].Free;

  except
    on e: exception do
      AddToLog('FinalNow', e.Message);
  end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  InitFolder;
  Edit30.Text := AppName;
  Edit31.Text := AppDir;

  // ݒt@C[h
  LoadIniFile;

  {$IFDEF ANDROID}
  // ŏ㕔̒ʒmo[\邽߂ɕKv
  Self.BorderStyle := TFmxFormBorderStyle.Sizeable;
  // Back{^̃^bvoiBack{^ŃAvIȂ悤ɂj
  Self.OnKeyUp := FormKeyUp;
  {$ENDIF}

  {$IFDEF DEBUG}
  Button1.Visible := true;
  {$ELSE}
  Button1.Visible := false;
  {$ENDIF}

  EEW_Rec := System.Default(TEEWRec);
  FEqID := '';

  MakeMaskArray;

  // Bitmap ̍쐬
  FMainBitmap := TBitmap.Create(Ex_MapSize.cx, Ex_MapSize.cy);
  FFramedBitmap := TBitmap.Create(MapSize.cx, MapSize.cy);
  FFramedBitmap.Clear(TAlphaColorRec.White);
  FMapBitmap := TBitmap.Create(Ex_MapSize.cx, Ex_MapSize.cy);
  FMonitorBitmap := TBitmap.Create(Ex_MapSize.cx, Ex_MapSize.cy);
  FWavesBitmap := TBitmap.Create(Ex_MapSize.cx, Ex_MapSize.cy);
  FInfoBitmap := TBitmap.Create(Ex_MapSize.cx, Ex_MapSize.cy);
  FInfoBitmap.Clear(0);

  FSaveBitmap := false;
  FEqID := '';
  FLastScreenshot := 0;
  FEEWState := false;

  // eCX^X̍쐬
  InitNow;

  FMapBitmapReady := false;
  CreateMap;
  InitGrid;
  FInfoBitmapEnabled := false;

  // SpotList
  SpotList := GetSpotList;
  // ݒñZbg
  SpeedButton1Click(nil);

  // e탏[JXbh̍쐬
  FEEWAccess := TEEWAccess.Create;
  FEEWAccess.Start;
  FKyoshinAccess := TKyoshinAccess.Create;
  FKyoshinAccess.Start;
  FEstIntAccess := TEstIntAccess.Create;
  FEstIntAccess.Start;
  FPSWavesAccess := TPSWavesAccess.Create;
  FPSWavesAccess.Start;

  FLastDrawTime := 0;
  FLastListShindoTime := 0;
  FBottomBaseExpanded := false;

  Application.OnException := OnApplicationException;

end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  AppClosing := true;
  MainLoop.Enabled := false;

  try
    FEEWAccess.Free;
    FKyoshinAccess.Free;
    FEstIntAccess.Free;
    FPSWavesAccess.Free;

    FMainBitmap.Free;
    FFramedBitmap.Free;
    FMapBitmap.Free;
    FMonitorBitmap.Free;
    FWavesBitmap.Free;
    FInfoBitmap.Free;

    FJmaScale.Free;
    FJmaScaleGrad.Free;
    FKyoshinScale.Free;

    FinalNow;

    ClearSpotList(SpotList);

    SaveIniFile;

  except

  end;
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
  Self.OnShow := nil;

  SetKyoshinInfoPanel;

  {$IFDEF MSWINDOWS}
  Layout1.OnClick := Layout1Click;
  {$ENDIF}
  {$IFDEF ANDROID}
  ChangeFontSizeOfCombo(ComboBox1);
  ChangeFontSizeOfCombo(ComboBox2);
  {$ENDIF}

  ImageBase.Height := ImageBase.Width * (Ex_MapSize.cy / Ex_MapSize.cx);
  BottomBase.BoundsRect := BottomBox.BoundsRect;

  // ColorScale
  ColorScaleBase.Height :=ImageBase.Height / 2.5;
  ColorScaleBase.Width := ColorScaleBase.Height * (55 / 301);

  // Shindo Scale
  FJmaScale := LoadBitmapFromResource('JmaScale');
  FJmaScaleGrad := LoadBitmapFromResource('JmaScaleGrad');
  FKyoshinScale  := LoadBitmapFromResource('KyoshinScale');


  SetUIOnImageBase;                            // ImageBsse̊eLayoutʒuZbg(SAJ[XP[AkxXg)

  // u݂̐kxv{bNX
  ShindoListBase.Visible := false;

  KyoshinIndex := TKyoshinIndex.KIacmap_s;     // n\őxɃZbg
  ComboBox2Change(nil);

  TabControl1.TabIndex := 0;

  UpDateMainImage;                             // ʍĕ`

  NextAccessTime := 0;
  MainLoop.Enabled := true;                    // C[ṽX^[g

  SpinBox4.Value := MinShindoScale;

  SetKyoshinTime;

end;

// e֐ŕߑłȂG[̔O
procedure TMainForm.OnApplicationException(Sender: TObject; E: Exception);
begin
  TFile.AppendAllText('Error.log', FormatDateTime('yyyy/mm/dd hh:nn:ss-', Now) +
                      'TMainForm.OnApplicationException: ' + e.Message + sLineBreak,
                      TEncoding.UTF8);
end;

{$IFDEF ANDROID}
// back{^ŃAvIȂ悤ɂ
procedure TMainForm.FormKeyUp(Sender: TObject; var Key: Word; var KeyChar: Char;
  Shift: TShiftState);
var
  FService : IFMXVirtualKeyboardService;
begin
  if Key = vkHardwareBack then begin
    try
      TPlatformServices.Current.SupportsPlatformService(IFMXVirtualKeyboardService, IInterface(FService));
      if (FService <> nil) and (TVirtualKeyboardState.Visible in FService.VirtualKeyBoardState) then begin
          // VirtualKeyBoard closes if it is visible

      end else if Popup1.IsOpen then begin
        Popup1.IsOpen := false;;
        Key := 0;
      end else begin
        // exit dialog
        TDialogService.MessageDialog('AvI܂H', TMsgDlgType.mtConfirmation,
          [TMsgDlgBtn.mbYes, TMsgDlgBtn.mbNo], TMsgDlgBtn.mbNo, 0,
          procedure (const AResult: TModalResult) begin
            if AResult = mrYes then
              Close;
          end);
        Key := 0;
      end;
    except
      on e: exception do
        AddToLog('TMainForm.FormKeyUp', e.Message);
    end;
  end;

end;
{$ENDIF}

// ݒt@C̓Ǎ
procedure TMainForm.LoadIniFile;
var
  AIni: TIniFile;
  V: integer;
begin
  AIni := TIniFile.Create(AppDir + PathDelim + AppName + '.ini');
  try
    {$IF DEFINED(MSWINDOWS) or DEFINED(MACOS)}
    Self.Left := AIni.ReadInteger('Form', 'Left', 100);
    Self.Top := AIni.ReadInteger('Form', 'Top', 100);
    {$ENDIF}
    SpinBox6.Value := AIni.ReadInteger('Kyoshin', 'Delay', 1300);
    SpinBox3.Value := AIni.ReadInteger('Kyoshin', 'MinScale', 20);
    Switch3.IsChecked := AIni.ReadBool('Kyoshin', 'NoiseEnabled', true);
    SpinBox9.Value := AIni.ReadInteger('Kyoshin', 'NoiseThreshold', 8);
    SpinBox5.Value := AIni.ReadInteger('Kyoshin', 'DrawRadius', 4);
    SpinBox4.Value := AIni.ReadInteger('Kyoshin', 'MinShindoScale', 35);
    Switch4.IsChecked := AIni.ReadBool('Kyoshin', 'ShindoValueEnabled', true);
    V := AIni.ReadInteger('Kyoshin', 'ShindoColor', 2);
    case V of
      0: RadioButton4.IsChecked := true;
      1: RadioButton5.IsChecked := true;
      2: RadioButton6.IsChecked := true;
    end;
    Switch5.IsChecked := AIni.ReadBool('Kyoshin', 'EEWCaptureEnabled', false);
    V := AIni.ReadInteger('Kyoshin', 'EEWCaptureBase', 1);
    case V of
      0: RadioButton3.IsChecked := true;
      1: RadioButton1.IsChecked := true;
      2: RadioButton2.IsChecked := true;
    end;
    {$IFDEF DEBUG}
    Switch2.IsChecked := true;
    IsDebug := true;
    {$ELSE}
    Switch2.IsChecked := AIni.ReadBool('Kyoshin', 'IsDebug', false);
    IsDebug := Switch2.IsChecked;
    {$ENDIF}

  finally
    AIni.Free;
  end;
end;

// ݒt@C̏
procedure TMainForm.SaveIniFile;
var
  AIni: TIniFile;
begin
  AIni := TIniFile.Create(AppDir + PathDelim + AppName + '.ini');
  try
    {$IF DEFINED(MSWINDOWS) or DEFINED(MACOS)}
    AIni.WriteInteger('Form', 'Left', Self.Left);
    AIni.WriteInteger('Form', 'Top', Self.Top);
    {$ENDIF}
    AIni.WriteInteger('Kyoshin', 'Delay', Round(SpinBox6.Value));
    AIni.WriteInteger('Kyoshin', 'MinScale', Round(SpinBox3.Value));
    AIni.WriteBool('Kyoshin', 'NoiseEnabled', Switch3.IsChecked);
    AIni.WriteInteger('Kyoshin', 'NoiseThreshold', Round(SpinBox9.Value));
    AIni.WriteInteger('Kyoshin', 'DrawRadius', Round(SpinBox5.Value));
    AIni.WriteInteger('Kyoshin', 'MinShindoScale', Round(SpinBox4.Value));
    AIni.WriteBool('Kyoshin', 'ShindoValueEnabled', Switch4.IsChecked);
    if RadioButton4.IsChecked then
      AIni.WriteInteger('Kyoshin', 'ShindoColor', 0)
    else if RadioButton5.IsChecked then
      AIni.WriteInteger('Kyoshin', 'ShindoColor', 1)
    else if RadioButton6.IsChecked then
      AIni.WriteInteger('Kyoshin', 'ShindoColor', 2);
    AIni.WriteBool('Kyoshin', 'EEWCaptureEnabled', Switch5.IsChecked);
    if RadioButton3.IsChecked then
      AIni.WriteInteger('Kyoshin', 'EEWCaptureBase', 0)
    else if RadioButton1.IsChecked then
      AIni.WriteInteger('Kyoshin', 'EEWCaptureBase', 1)
    else if RadioButton2.IsChecked then
      AIni.WriteInteger('Kyoshin', 'EEWCaptureBase', 2);
    AIni.WriteBool('Kyoshin', 'IsDebug', Switch2.IsChecked);

  finally
    AIni.Free;
  end;
end;


// add 2023-07-25
// eʗvfn}\͈͂ɉĈړ
procedure TMainForm.SetUIOnImageBase;
begin
  case MapDrawRect of
    TMapDrawRect.mrLeftTop:
      begin
        // ColorScaleImageBase
        ColorScaleBase.Position.X := 8;
        ColorScaleBase.Position.Y := ImageBase.Height - 8 - ColorScaleBase.Height;
        // LogoImageBase
        LogoImageBase.Position.X := ImageBase.Width - 8 - LogoImageBase.Width;
        LogoImageBase.Position.Y := ImageBase.Height - 8 - LogoImageBase.Height;
        // ShindoListBase
        ShindoListBase.Position.X := 0;
        ShindoListBase.Position.Y := Rectangle9.Height;

        DisplayedMapRect := TRect.Create(Point(48, 0), 352, 400);
      end;
    TMapDrawRect.mrRightTop:       // ʏʒu
      begin
        // ColorScaleImageBase
        ColorScaleBase.Position.X := ImageBase.Width - 8 - ColorScaleBase.Width;
        ColorScaleBase.Position.Y := ImageBase.Height - 8 - ColorScaleBase.Height;
        // LogoImageBase
        LogoImageBase.Position.X := ColorScaleBase.Position.X - 32 - LogoImageBase.Width;
        LogoImageBase.Position.Y := ImageBase.Height - 8 - LogoImageBase.Height;
        // ShindoListBase
        ShindoListBase.Position.X := 0;
        ShindoListBase.Position.Y := Rectangle9.Height;

        // MapRect for repaint
        DisplayedMapRect := TRect.Create(Point(124, 0), 352, 400);

      end;
    TMapDrawRect.mrLeftBottom:
      begin
        // ColorScaleImageBase
        ColorScaleBase.Position.X := 8;
        ColorScaleBase.Position.Y := Rectangle9.Height + 8;
        // LogoImageBase
        LogoImageBase.Position.X := Rectangle9.Width + 8;;
        LogoImageBase.Position.Y := 4;
        // ShindoListBase
        ShindoListBase.Position.X := ImageBase.Width - ShindoListBase.Width;
        ShindoListBase.Position.Y := ImageBase.Height - ShindoListBase.Height;

        DisplayedMapRect := TRect.Create(Point(0, 157), 352, 400);
      end;
    TMapDrawRect.mrRightBottom:
      begin
        // ColorScaleImageBase
        ColorScaleBase.Position.X := ImageBase.Width - 8 - ColorScaleBase.Width;
        ColorScaleBase.Position.Y := 8;
        // LogoImageBase
        LogoImageBase.Position.X := ImageBase.Width - 8 - LogoImageBase.Width;
        LogoImageBase.Position.Y := ImageBase.Height - 8 - LogoImageBase.Height;
        // ShindoListBase
        ShindoListBase.Position.X := 0;
        ShindoListBase.Position.Y := ImageBase.Height - ShindoListBase.Height;

        DisplayedMapRect := TRect.Create(Point(124, 157), 352, 400);
      end;
    TMapDrawRect.mrAll:
      begin
        // ColorScaleImageBase
        ColorScaleBase.Position.X := ImageBase.Width - 8 - ColorScaleBase.Width;
        ColorScaleBase.Position.Y := ImageBase.Height - 8 - ColorScaleBase.Height;
        // LogoImageBase
        LogoImageBase.Position.X := ColorScaleBase.Position.X - 32 - LogoImageBase.Width;
        LogoImageBase.Position.Y := ImageBase.Height - 8 - LogoImageBase.Height;
        // ShindoListBase
        ShindoListBase.Position.X := 0;
        ShindoListBase.Position.Y := Rectangle9.Height;

        // MapRect for repaint
        DisplayedMapRect := FMainBitmap.Bounds;

      end;
  end;
end;

// Crbg}bv̐؂ʒuύX
procedure TMainForm.SpeedButton4Click(Sender: TObject);
begin
  if ssShift in FShiftState then
    MapDrawRect := TMapDrawRect.mrLeftTop
  else if ssCtrl in FShiftState then
    MapDrawRect := TMapDrawRect.mrRightBottom
  else begin
    if MapDrawRect = TMapDrawRect.mrRightTop then
      MapDrawRect := TMapDrawRect.mrLeftBottom
    else
      MapDrawRect := TMapDrawRect.mrRightTop;
  end;

  SetUIOnImageBase;
end;

procedure TMainForm.SpeedButton4MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Single);
begin
  FShiftState := Shift;
end;

var
  FrameOrgRect: TRect = (Left:0; Top:49; Right:171; Bottom:207);
  MovedFrameRect: TRect = (Left:0; Top:398; Right:171; Bottom:556);
  FrameLinePoint0: TPoint = (X:173; Y:51);
  FrameLinePoint1: TPoint = (X:173; Y:135);
  FrameLinePoint2: TPoint = (X:111; Y:208);
  FrameLinePoint3: TPoint = (X:0; Y:208);

// kj^wW{bNXђn}g̈ʒuETCY̏
procedure TMainForm.SetKyoshinInfoPanel;
begin
  Self.Rectangle9.Width := Self.PaintBox1.Width / 2;
  Self.Rectangle9.Position.X := 0;
  Self.Rectangle9.Position.Y := 0;

  Self.Label4.Font.Size := AdjustLabelFontSize('2023-12-26 23:12:34', Self.Label4.Font,
                                  Self.Rectangle9.Width - 8 * 2 - 1);
  Self.Label4.Align := TAlignLayout.None;
  Self.Label4.Text := FormatDateTime('yyyy-mm-dd hh:nn:ss', Clock);
  Self.Rectangle9.Height := 4 * 3 + Self.Label11.Height +
                                      Self.Label4.Height;
  Self.Label4.Align := TAlignLayout.Client;

  // ʘg g
  var ATop := Round(Rectangle9.BoundsRect.Bottom) - 41;
  FrameOrgRect.Offset(0, ATop);
  FrameLinePoint0.Offset(0, ATop);
  FrameLinePoint1.Offset(0, ATop);
  FrameLinePoint2.Offset(0, ATop);
  FrameLinePoint3.Offset(0, ATop);
end;

// BottomBox̐Lk

// Android: XN[ŉ̃obN^z[{^̗LɂBottomBox̍ςKv
procedure TMainForm.BottomBoxResize(Sender: TObject);
begin
  if not FBottomBaseExpanded then
    BottomBase.BoundsRect := BottomBox.BoundsRect
  else
    BottomBase.BoundsRect := RectF(0, FormBase.Height / 2, BottomBox.BoundsRect.Right, BottomBox.BoundsRect.Bottom);

end;

// android: swipe
procedure TMainForm.Layout1Gesture(Sender: TObject;
  const EventInfo: TGestureEventInfo; var Handled: Boolean);
begin
  if (EventInfo.GestureID = sgiUp) and not FBottomBaseExpanded then begin
    FBottomBaseExpanded := true;
    BottomBase.BoundsRect := RectF(0, FormBase.Height / 2, BottomBox.BoundsRect.Right, BottomBox.BoundsRect.Bottom);
    Handled := true;
  end else if (EventInfo.GestureID = sgiDown) and FBottomBaseExpanded then begin
    FBottomBaseExpanded := false;
    BottomBase.BoundsRect := BottomBox.BoundsRect;
    Handled := true;
  end;
end;

// Windows Click
{$IFDEF MSWINDOWS}
procedure TMainForm.Layout1Click(Sender: TObject);
begin
  FBottomBaseExpanded := not FBottomBaseExpanded;
  if FBottomBaseExpanded then
    BottomBase.BoundsRect := RectF(0, FormBase.Height / 2, BottomBox.BoundsRect.Right, BottomBox.BoundsRect.Bottom)
  else
    BottomBase.BoundsRect := BottomBox.BoundsRect;
end;
{$ENDIF}

// ComboBox̃tHgTCYݒ
procedure TMainForm.ChangeFontSizeOfCombo(ComboBox: TComboBox);
var
  Item: TListBoxItem;
begin
  if ComboBox.Items.Count > 0 then
    for var i := 0 to ComboBox.Items.Count - 1 do begin
      Item := ComboBox.ListItems[i];
      Item.Font.Size := 12;
      Item.StyledSettings := Item.StyledSettings - [TStyledSetting.Size];
    end;
end;

// C摜̍ĕ`
procedure TMainForm.PaintBox1Paint(Sender: TObject; Canvas: TCanvas);
begin
  if FMapBitmapReady then
    Canvas.DrawBitmap(FFramedBitmap, FFramedBitmap.Bounds,
                      RectF(0, 0, PaintBox1.Width, PaintBox1.Height), 1.0);
end;

// I{^ioCOS: obNOEhœ삵邱ƂȂ悤ɊmɃAv𑦎Ij
procedure TMainForm.SpeedButton2Click(Sender: TObject);
begin
  AppClosing := true;
  MainLoop.Enabled := false;
  Close;
end;

procedure TMainForm.Switch1Switch(Sender: TObject);
begin
  DetectMicroEq := Switch1.IsChecked;
end;

procedure TMainForm.Switch2Switch(Sender: TObject);
begin
  IsDebug := Switch2.IsChecked;
end;

// ^u̐؂ւ
procedure TMainForm.TabButtonClick(Sender: TObject);
begin
  if TSpeedButton(Sender).Tag < TabControl1.TabCount then
    TabControl1.TabIndex := TSpeedButton(Sender).Tag;
end;

// ^Cgo[̃hbOŃEBhEړifXNgbvAv̂݁j
procedure TMainForm.TopBaseMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Single);
begin
  {$IFNDEF ANDORID}
  Self.StartWindowDrag;
  {$ENDIF}
end;

procedure TMainForm.DrawCityOnMap(City: string; SList: TStringList);
var
  SArray: TStringDynArray;
  APoint: TPoint;
  ARect: TRectF;
begin
  try
    SArray  := SplitString(SList.Values[City], ',');
    if Length(SArray) = 3 then begin
      ARect := GetTextRect(City, FMapBitmap.Canvas.Font);
      APoint := Get_Ex_MapPos(TPointF.Create(SArray[2].ToSingle, SArray[1].ToSingle));
      if City = 'ߔe' then
        ARect.Offset(APoint.X, APoint.Y)
      else
        ARect.Offset(APoint.X - ARect.Width / 2, APoint.Y - ARect.Height / 2);
      FMapBitmap.Canvas.FillText(ARect, City, false, 1.0, [], TTextAlign.Leading, TTextAlign.Leading);
    end;
  except
    on e: exception do
      AddToLog('TMainForm.DrawCityOnMap', e.Message)
  end;
end;

// n}̏
procedure TMainForm.CreateMap;
const
  MapBack = $FF707070;
var
  ABitmap, TheBitmap: TBitmap;
  ARect: TRect;
  BitmapData: TBitmapData;
  SrcLine: PAlphaColorArray;
  AColor: TAlphaColor;
  SList: TStringList;
begin
  ABitmap := nil;
  // kj^̃TCg_[N[hp̒n}_E[h
  ABitmap := GetBitmapFromSite('http://www.kmoni.bosai.go.jp/data/map_img/CommonImg/base_map_b.gif');
  if ABitmap <> nil then begin
    try
      try
        FMapBitmap.Clear(MapBack);

        // ʘgiEj̈ʒuɈړ
        MoveFrame(ABitmap, FMapBitmap, MapBack, false);
        FreeAndNIl(ABitmap);

        if FMapBitmap.Canvas.BeginScene then
          try
            // ʘg̘gn}̔wiFœhׂ
            ARect := TRect.Create(Point(122, 49), 177, 162);
            FMapBitmap.Canvas.Fill.Color := MapBack;
            FMapBitmap.Canvas.FillRect(ARect, 1.0);
            // hЉȌS폜
            ARect := TRect.Create(Point(275, 355), 146, 44);
            FMapBitmap.Canvas.Fill.Color := MapBack;
            FMapBitmap.Canvas.FillRect(ARect, 1.0);
          finally
            FMapBitmap.Canvas.EndScene;
          end;

        // FxCĒF
        if FMapBitmap.Map(TMapAccess.ReadWrite, BitmapData) then
          try
            var AColorRec: TAlphaColorRec;
            for var Y := 0 to BitmapData.Height - 1 do begin
              SrcLine := BitmapData.GetScanline(Y);
              for var X := 0 to BitmapData.Width - 1 do begin
                AColorRec.Color := SrcLine^[X];
                AColorRec.R := $FF - Min(255, Round(AColorRec.R * 1.3));
                AColorRec.G := $FF - Min(255, Round(AColorRec.G * 1.0));
                AColorRec.B := $FF - Min(255, Round(AColorRec.B * 0.5));
                {$IFDEF MSWINDOWS}
                SrcLine^[X] := AColorRec.Color;
                {$ELSE}
                SrcLine^[X] := RGBToBGR(AColorRec.Color);
                {$ENDIF}
              end;
            end;
          finally
            FMapBitmap.UnMap(BitmapData);
          end;

        // n`
        SList := TStringList.Create;
        try
          SList.Text := LoadTextFromResource('CityLabel');
          if SList.Count > 0 then begin
            if FMapBitmap.Canvas.BeginScene then
              try
                // es{̌ݒn\\
                FMapBitmap.Canvas.Fill.Color := $B0FFFFFF;
                FMapBitmap.Canvas.Font.Size := 10;
                DrawCityOnMap('Dy', SList);
                DrawCityOnMap('', SList);
                DrawCityOnMap('', SList);
                // DrawCityOnMap('V', SList);
                // DrawCityOnMap('É', SList);
                DrawCityOnMap('', SList);
                // DrawCityOnMap('L', SList);
                // DrawCityOnMap('m', SList);
                DrawCityOnMap('', SList);
                DrawCityOnMap('ߔe', SList);


              finally
                FMapBitmap.Canvas.EndScene;
              end;
          end;
        finally
          SList.Free;
        end;

        // Skj^̃TCg_E[h
        ABitmap := GetBitmapFromSite('https://www.bosai.go.jp/about/img/logo_taglinemaster.png');
        if ABitmap <> nil then begin
          // ꕔVBitmapɃRs[
          TheBitmap := TBitmap.Create(300, 90);
          try
            ARect := TRect.Create(Point(40, 65), 300, 90);
            if TheBitmap.Canvas.BeginScene then begin
              try
                TheBitmap.Canvas.Clear(0);
                TheBitmap.Canvas.DrawBitmap(ABitmap, ARect, TheBitmap.Bounds, 1.0);
              finally
                TheBitmap.Canvas.EndScene;
              end;
            end;
            ARect := TRect.Create(Point(1, 2), 67, 67); // }[N
            // ̕~]ăO[#c0c4c5 𔒐F
            if TheBitmap.Map(TMapAccess.ReadWrite, BitmapData) then begin
              try
                var AColorRec: TAlphaColorRec;
                var Ratio: single := 1.34;
                for var Y := 0 to BitmapData.Height - 1 do begin
                  SrcLine := BitmapData.GetScanline(Y);
                  for var X := 0 to BitmapData.Width - 1 do begin
                    // }[NȊO̕
                    if not ARect.Contains(Point(X, Y)) then begin
                      AColor := SrcLine^[X];
                      if AColor AND $FF000000 > 0 then begin // Alpha > 0
                        AColor := AColor XOR $FFFFFF; // ̕~]
                        // O[#c0c4c5 𔒐F
                        AColorRec.Color := AColor;
                        AColorRec.R := Min(255, Round(AColorRec.R * Ratio));
                        AColorRec.G := Min(255, Round(AColorRec.G * Ratio));
                        AColorRec.B := Min(255, Round(AColorRec.B * Ratio));
                        AColorRec.A := 255;
                        SrcLine^[X] := AColorRec.Color;
                      end;
                    end;
                  end;
                end;
              finally
                TheBitmap.UnMap(BitmapData);
              end;
              // delete 2023-07-23 n}BitmapɖhЉȌS\t
              LogoImage.Bitmap.Assign(TheBitmap);
            end;
          finally
            TheBitmap.Free;
          end;
        end;

      except
        on e: exception do
          AddToLog('TMainForm.CreateMap', e.Message);
      end;
    finally
      ABitmap.Free;
    end;
  end;

  FMapBitmapReady := true;

end;

// EEWڃXg̕\
procedure TMainForm.InitGrid;
const
  Keys: array[0..12] of string = ('\', 'nk ID', 'ԍ', 'LZ', 'x',
    'ŏI', '', 'kn',
    'koܓx', 'kW', '[', '}Oj`[h', 'őkx');
begin
  for var i := Low(Keys) to High(Keys) do
    StringGrid1.Cells[0, i] := Keys[i];
end;

// kj^wW̕ύX
procedure TMainForm.ComboBox2Change(Sender: TObject);
begin
  KyoshinIndex := TKyoshinIndex(ComboBox1.ItemIndex * 8 + ComboBox2.ItemIndex);
  if (KyoshinIndex < TKyoshinIndex.KIacmap_s) or (KyoshinIndex > TKyoshinIndex.KIrsp1000_b) then
    exit;
  Label11.Text := KyoshinIndexDisplayStr[KyoshinIndex];

  // kj^wW̕ύXƂɁAJ[XP[TCg_E[hĕ\
  // XP[̓CBitmapɕ`悵ȂŕLayoutImageR|[lgɕ\iDPI΍j

  // XP[_E[h
  TThread.CreateAnonymousThread(procedure
  const
    ScaleURL = 'http://www.kmoni.bosai.go.jp/data/map_img/ScaleImg/nied_%KyoshinIndexURLStr%_w_scale.gif';
  var
    URL: string;
    ABitmap: TBitmap;
    BitmapData: TBitmapData;
    Line: PAlphaColorArray;
    AColor: TAlphaColorRec;
  begin
    URL := ScaleURL.Replace('%KyoshinIndexURLStr%', KyoshinIndexURLStr[KyoshinIndex]);
    ABitmap := GetBitmapFromSite(URL);
    if ABitmap <> nil then begin
      try
        try
          if ABitmap.Map(TMapAccess.ReadWrite, BitmapData) then begin
            try
              // Ȃ_[N[hp̃XP[F̂܂܂Ȃ̂ŃO[F͔]Ĕ
              for var y := 0 to BitmapData.Height - 1 do begin
                Line := BitmapData.GetScanline(y);
                for var x := 0 to BitmapData.Width -  1 do begin
                  if Line^[x] AND $FF000000 > 0 then begin   // wi
                    AColor.Color := Line^[x];
                    // O[甽]
                    if (AColor.R = AColor.G) and (AColor.R =  AColor.B) then
                      Line^[x] := Line^[x] XOR $FFFFFF;
                  end;
                end;
              end;
            finally
              ABitmap.UnMap(BitmapData);
            end;
          end;

          if ABitmap.Width > 0 then begin
            TThread.Synchronize(TThread.CurrentThread,
            procedure
            begin
              ScaleImage.Bitmap.Assign(ABitmap);
            end);
          end;
        except
          on e: exception do
            AddToLog('TMainForm.ComboBox2Change', e.Message);
        end;
      finally
        ABitmap.Free;
      end;
    end;
  end).Start;
end;

// ݒn̍ŋߊϑ_4_ݒ肷
procedure TMainForm.SetNearestSpots;
  // SpotListݒn̋Ń\[g
  function SortByDistanceFromCurrentPoint: boolean;
  var
    Rec: PKyoshinRec;
    i: integer;
  begin
    result := false;

    if (SpotList <> nil) and (SpotList.Count > 0) and
       (CurrentPointF.X <> 0) and (CurrentPointF.Y <> 0) then begin
      try
        for i := 0 to SpotList.Count - 1 do begin
          Rec := SpotList.Items[i];
          Rec.Distance := GetHubenyDistance(Rec.GeoPoint, CurrentPointF);
        end;
        SpotList.SortList(function (Item1, Item2: Pointer): Integer
          begin
            result := CompareValue(PKyoshinRec(Item1).Distance, PKyoshinRec(Item2).Distance);
          end);
        result := true;
      except

      end;
    end;
end;
var
  i: integer;
  Rec: PKyoshinRec;
begin
  if SpotList <> nil then begin
    try
      // ϑ_Xg\[g
      if SortByDistanceFromCurrentPoint then begin
        for i := 0 to 3 do begin
          Rec := SpotList.Items[i];
          NearestSpots[i].Index := Rec.Index;
          NearestSpots[i].Name := Rec.Name;
          NearestSpots[i].LonLat := Rec.GeoPoint;
          NearestSpots[i].ScanPoint := Rec.ScanPoint;
          NearestSpots[i].Scale := 0;
        end;
      end;
    except
      on e: exception do
        AddToLog('TMainForm.SetNearestSpots', e.Message);
    end;
  end;
end;

// kj^EEBhEXV
procedure TMainForm.UpDateMainImage;
var
  APoint: TPoint;
  ARect: TRect;
begin
  // n}łĂȂI
  if not FMapBitmapReady or AppClosing then
    Exit;

  try
    CurrentPointF := TPointF.Create(SpinBox2.Value, SpinBox1.Value);
    CurrentPoint := Get_Ex_MapPos(CurrentPointF);

    if FMainBitmap.Canvas.BeginScene then begin
      try
        // C̐FŃNA
        FMainBitmap.Canvas.Clear($FFFEFDFD);
        // n}CBitmapɕ`
        FMainBitmap.Canvas.DrawBitmap(FMapBitmap, FMapBitmap.Bounds, FMainBitmap.Bounds, 1.0);
        // kj^摜CBitmapɕ`
        FMainBitmap.Canvas.DrawBitmap(FMonitorBitmap, FMonitorBitmap.Bounds, FMainBitmap.Bounds, 1.0);
        // ϑ_͈̔   add 2023-07-23
        FMainBitmap.Canvas.DrawBitmap(FInfoBitmap, FInfoBitmap.Bounds, FMainBitmap.Bounds, 1.0);
        if EEWState {or IsDebug} then
          // EEWɂPSg~摜CBitmapɕ`
          FMainBitmap.Canvas.DrawBitmap(FWavesBitmap, FWavesBitmap.Bounds, FMainBitmap.Bounds, 1.0);
        // ݒn}[J[CBitmapɕ`
        APoint := Get_Ex_MapPos(TPointF.Create(SpinBox2.Value, SpinBox1.Value));
        ARect := TRect.Create(Point(APoint.X - 8, APoint.Y - 16), 16, 16);
        ImageList1.Draw(FMainBitmap.Canvas, ARect, 2, 1.0);
      finally
        FMainBitmap.Canvas.EndScene;
      end;
    end;

    if AppClosing then exit;

    // C摜̈ꕔ؂
    if FFramedBitmap.Canvas.BeginScene then
      try
        if EEWState and not EEW_Rec.EpicenterF.IsZero then begin


        end;

        FFramedBitmap.Canvas.DrawBitmap(FMainBitmap, DisplayedMapRect, FFramedBitmap.Bounds, 1.0);

        // E̕ʘg̏
        if not EEWState and (MapDrawRect = TMapDrawRect.mrRightTop) then begin
          FFramedBitmap.Canvas.DrawBitmap(FMainBitmap, MovedFrameRect, FrameOrgRect, 1.0);
          // g
          FFramedBitmap.Canvas.Stroke.Color := TAlphaColorRec.White;
          FFramedBitmap.Canvas.Stroke.Thickness := 1;
          FFramedBitmap.Canvas.DrawLine(FrameLinePoint0, FrameLinePoint1, 1.0);
          FFramedBitmap.Canvas.DrawLine(FrameLinePoint1, FrameLinePoint2, 1.0);
          FFramedBitmap.Canvas.DrawLine(FrameLinePoint2, FrameLinePoint3, 1.0);
        end;

      finally
        FFramedBitmap.Canvas.EndScene;
      end;


    // CC[W̍ĕ`
    PaintBox1.Repaint;

  except
    on e: exception do
      AddToLog('TMainForm.UpDateMainImage', e.Message);
  end;
end;

// kj^Ԃ̌vZ
// kj^擾摜͊{I1.3b̒xiT[ȍԂɂϓj
//   F ^CX^v12:00:00̃f[^/摜12:00:01.300ȍ~ɃANZX
// {c[ł́A1.3bォHEADŃt@C݂̑m߁A100msԊuōő4񃊃gC
// t@C݂̑mFłGETŎ擾procedure TMainForm.SetKyoshinTime;

procedure TMainForm.SetKyoshinTime;
var
  AClock: TDateTime;
  KyoshinTimeStamp: TDateTime;
  AccessDelay: integer;
begin
  try
    AClock := Clock;
    AccessDelay := Round(SpinBox6.Value) mod 1000;
    if MilliSecondOf(AClock) > AccessDelay  then begin
      KyoshinTimeStamp := RecodeMilliSecond(AClock, 0);
      NextAccessTime := IncSecond(RecodeMilliSecond(AClock, AccessDelay), 1);
    end else begin
      KyoshinTimeStamp := IncSecond(RecodeMilliSecond(AClock, 0), -1);
      NextAccessTime := RecodeMilliSecond(AClock, AccessDelay);
    end;

    // NTPς݂ǂ
    if not NTPAdjusted then
      NextKyoshinTime := IncSecond(KyoshinTimeStamp, -2)
    else
      NextKyoshinTime := KyoshinTimeStamp;

    // v񐔂L^
    TInterlocked.Increment(RequestCount);

  except
    on e: exception do
      AddToLog('TMainForm.SetKyoshinTime', e.Message);
  end;
end;


procedure TMainForm.MainLoopTimer(Sender: TObject);
var
  Folder, Filename: string;
begin
  MainLoop.Enabled := false;

  if AppClosing then Exit;

  try
    try
      // EEW[hɂȂEEW^uɐ؂ւ
      if EEWState and (FEEWState <> EEWState) then begin
        FEEWState := EEWState;
        TabControl1.TabIndex := 1;
      end else if not EEWState and (FEEWState <> EEWState) then begin
        FEEWState := EEWState;

      end;


      // ̋kj^̃f[^󂯎鏀
      if IncMilliSecond(NextAccessTime, 600) <= Clock then
        SetKyoshinTime;   // ̉摜^CX^vƃANZXݒ

      if AppClosing then Exit;

      // take a screenshot every sec during EEW
      if not FEqID.IsEmpty and Switch5.IsChecked and (MilliSecondsBetween(FLastScreenshot, Clock) > 1000) then begin
        FLastScreenshot := Clock;
        Folder := CaptureDir + PathDelim + FEqID;
        if not TDirectory.Exists(Folder) then
          TDirectory.CreateDirectory(Folder);
        Filename := FormatDateTime('yyyymmdd_hhnnss', Clock) + '.png';
        if RadioButton1.IsChecked then
          ScreenShot(Folder + PathDelim + Filename, FormBase)
        else if RadioButton3.IsChecked then
          ScreenShot(Folder + PathDelim + Filename, ImageBase)
        else
          FMainBitmap.SaveToFile(Filename);
      end;

      if AppClosing then Exit;

      // Ȍ
      var Rec: PLogRec;
      Rec := PopFromQueue(LogQueue);
      while Rec <> nil do begin
        LogWriteToFile(Rec);
        Dispose(Rec);
        Rec := PopFromQueue(LogQueue);
      end;

      if AppClosing then Exit;

      // kj^ϑ_̕`您сu݂̐kxv\́Af[^ɔ4bԂ͏Ԃێ
      if (FLastDrawTime > 0) and (SecondsBetween(FLastDrawTime, Clock) > 4) then
        FMonitorBitmap.Clear(0);
      if (FLastListShindoTime > 0) and (SecondsBetween(FLastListShindoTime, Clock) > 4) then
        ShindoListBase.Visible := false;

      if AppClosing then Exit;

      // update info items
      // ANZX
      Edit9.Text := TInterlocked.Read(AccessSuccess).ToString;
      Edit7.Text := TInterlocked.Read(AccessError).ToString;
      Edit8.Text := TInterlocked.Read(AccessRetry).ToString;
      // v
      Edit18.Text := TInterlocked.Read(RequestCount).ToString;
      // 擾
      Edit17.Text := TInterlocked.Read(AcquisitImage).ToString;
      Edit21.Text := TInterlocked.Read(AcquisitEEW).ToString;
      Edit22.Text := TInterlocked.Read(AcquisitEst).ToString;
      Edit23.Text := TInterlocked.Read(AcquisitPS).ToString;
      // ϑ_
      Edit20.Text := TInterlocked.Read(SpotsCount).ToString;
      // FTŃubNTɎsAS100FT
      Edit24.Text := TInterlocked.Read(ColorSearch2Count).ToString;

      // NTPŎ擾݂̎\
      Edit29.Text := FormatDateTime('yyyy-mm-dd hh:nn:ss', Clock);

    except
      on e: exception do
        AddToLog('TMainForm.Timer1Timer', e.Message);
    end;
  finally
    if not AppClosing then
      MainLoop.Enabled := true;
  end;
end;


//
// ݒ
//

// ݒn̕ύXɑΉāAݒn̍Ŋϑ_ݒ肷
procedure TMainForm.SpeedButton1Click(Sender: TObject);
const
  GeocodingURL = 'https://geoapi.heartrails.com/api/json?method=searchByGeoLocation&x=LONGITUDE&y=LATITUDE';
begin
  CurrentPointF := TPointF.Create(SpinBox2.Value, SpinBox1.Value);
  CurrentPoint := Get_Ex_MapPos(CurrentPointF);

  SetNearestSpots;

  // ݒ肳ꂽoܓx̏Z擾
  TThread.CreateAnonymousThread(procedure
    var
      Url: string;
      Json: string;
      JSONObject: TJSONObject;
      JsonArray: TJsonArray;
      JsonPair, JsonItem: TJsonValue;
      Prefecture, City, Address: string;
    begin
      // city
      Url := GeocodingURL;
      Url := Url.Replace('LONGITUDE', CurrentPointF.X.ToString(TFloatFormat.ffFixed, 7, 2), [rfIgnoreCase]);
      Url := Url.Replace('LATITUDE', CurrentPointF.Y.ToString(TFloatFormat.ffFixed, 7, 2), [rfIgnoreCase]);
      Json := GetTextFromSite(Url);
      if not Json.IsEmpty then begin
        JSONObject := TJSONObject.ParseJSONValue(Json) as TJSONObject;
        if JSONObject <> nil then begin
          try
            try
              if JSONObject.TryGetValue('response.location', JsonPair) then begin
                JsonArray := JsonPair as TJsonArray;
                if JsonArray.Count > 0 then begin
                  JsonItem := JsonArray.Items[0];
                    if JsonItem.TryGetValue('prefecture', JsonPair) then begin
                      Prefecture := JsonPair.Value;
                      if JsonItem.TryGetValue('city', JsonPair) then begin
                        City := JsonPair.Value;
                        Address := Prefecture + City;
                      end;
                      if JsonItem.TryGetValue('town', JsonPair) then begin
                        City := JsonPair.Value;
                        Address := Address + City;
                      end;

                    end;
                end;
              end;
            except
              on e: exception do
                AddToLog('TMainForm.SpeedButton2Click', e.Message);
            end;
          finally
            JSONObject.Free;
          end;
        end;
        // UIɓs{EsZbg
        TThread.Synchronize(TThread.CurrentThread,
        procedure
        begin
          Edit27.Text := Address;
        end);
      end;
    end).Start;

end;

// n}\ ŏ`XP[i0..50j
procedure TMainForm.SpinBox3Change(Sender: TObject);
begin
  MinKyoshinScale := Round(SpinBox3.Value);
end;

// ݂̐kx ŏ\XP[ (0..50)
procedure TMainForm.SpinBox4Change(Sender: TObject);
begin
  MinShindoScale := Round(SpinBox4.Value);
end;

// mCY臒l
procedure TMainForm.SpinBox9Change(Sender: TObject);
begin
  NoiseThreshold := Round(SpinBox9.Value);
end;

// nk臒l
procedure TMainForm.SpinBox10Change(Sender: TObject);
begin
  MicroEqThreshold := Round(SpinBox10.Value);
end;

// SpinBoxł̃}EXzC[̓𖳎
procedure TMainForm.SpinBoxMouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: Integer; var Handled: Boolean);
begin
  {$IFDEF MSWINDOWS}
  Abort;
  {$ENDIF}
end;



//
// Lv`
//

// JACR̃NbN
procedure TMainForm.SpeedButton3Click(Sender: TObject);
begin
  // |bvAbvj[̕\
  Popup1.IsOpen := true;
end;

procedure TMainForm.ScreenShotMenuClick(Sender: TObject);
begin
  Popup1.IsOpen := false;
  var Filename := CaptureDir + Pathdelim + FormatDateTime('yyyymmdd_hhnnss', Clock) + '.png';
  case (Sender as TListBoxItem).Tag of
    0: Screenshot(Filename, FormBase);         // EBhEŜۑ
    1: Screenshot(Filename, ImageBase);        // Ct[ikj^Au݂̐kxvAXP[܂ށjۑ
    2: FMainBitmap.SaveToFile(Filename);       // C摜̂ݕۑ
    3: CopyBitmapToClipboard(FMainBitmap);     // C摜Rs[
  end;
end;

procedure TMainForm.ScreenShot(Filename: string; Base: TLayout);    // XN[Vbg
begin
  TThread.CreateAnonymousThread(procedure
  begin
    TThread.Synchronize(TThread.CurrentThread,
    procedure
    var
      ABitmap: TBitmap;
    begin
      ABitmap := Base.MakeScreenshot;
      if Assigned(ABitmap) then begin
        try
          try
              if ABitmap.Width > 0 then
                ABitmap.SaveToFile(Filename);
          except
            on e: exception do
              AddToLog('TMainForm.ScreenShot', e.Message);
          end;
        finally
          ABitmap.Free;
        end;
      end;
    end);
  end).Start;

end;


//
// ekj^XbhĂ΂
//

// n}̋kj^ϑ_̍XV
procedure TMainForm.UpdateKyoshinSpots(List: TList; DateTime: TDateTime; AKyoshinIndex: TKyoshinIndex);
var
  Rec: PKyoshinRec;
  ARect: TRect;
  Radius: integer;
  SwitchValue: boolean;
  MinScale: integer;
  DrawScale: integer;
begin
  if (List <> nil) and (List.Count > 0) then begin
    if FMonitorBitmap.Canvas.BeginScene then begin
      try
        FMonitorBitmap.Canvas.Clear(0);
        try
          SwitchValue := Switch3.IsChecked and NTPAdjusted;
          Radius := Round(SpinBox5.Value);     // ϑ_̉~a
          for var i := 0 to List.Count - 1 do begin
            if AppClosing then Exit;
            Rec := List.Items[i];

            if (AKyoshinIndex = TKyoshinIndex.KIacmap_s) and SwitchValue then
              DrawScale := Rec.AveragedScale
            else
              DrawScale := Rec.Scale;
            // alter 2023-07-23
            // ŏ`XP[ȏ̊ϑ_̂ݕ`
            MinScale := MinKyoshinScale;       // `ŏXP[
            if InRange(DrawScale, MinScale, 99) then begin
              FMonitorBitmap.Canvas.Fill.Color := KyoshinAlphaColors[DrawScale];
              ARect := TRect.Create(Rec.DispPoint.X - Radius, Rec.DispPoint.Y - Radius,
                                    Rec.DispPoint.X + Radius, Rec.DispPoint.Y + Radius);
              FMonitorBitmap.Canvas.FillEllipse(ARect, 1.0);
            end;
          end;

          FLastDrawTime := Clock;
        except
          on e: exception do
            AddToLog('TMainForm.UpdateKyoshinSpots', e.Message);
        end;
      finally
        FMonitorBitmap.Canvas.EndScene;
      end;
      Label4.Text := FormatDateTime('yyyy-mm-dd hh:nn:ss', DateTime);
    end;

    UpDateMainImage;

  end;
end;

// ً}nkUIɔf
procedure TMainForm.UpdateEEWDetails(Rec: PEEWRec);
const
  EpicenterRect_0: TRectF = (Left:127; Top:37.7; Right:133.3; Bottom:48);
  EpicenterRect_2: TRectF = (Left:118; Top:20; Right:135; Bottom:32.7);
  EpicenterRect_3: TRectF = (Left:135; Top:20; Right:160; Bottom:32.7);
begin
  UpdateEEWItems(Rec);
  // Debug: XN[Lv`̕ۑtH_ƂăZbg
  FEqID := Rec.ReportID;

  // n}̈ʒu̕ύX add 2023-07-25
  var MapRect := TMapDrawRect.mrRightTop;
  if EpicenterRect_0.Contains(Rec.EpicenterF) then
    MapRect := TMapDrawRect.mrLeftTop
  else if EpicenterRect_2.Contains(Rec.EpicenterF) then
    MapRect := TMapDrawRect.mrLeftBottom
  else if EpicenterRect_3.Contains(Rec.EpicenterF) then
    MapRect := TMapDrawRect.mrRightBottom;
  if MapDrawRect <> MapRect then begin
    MapDrawRect := MapRect;
    SetUIOnImageBase
  end;
end;

// ً}nkXgɕ\
procedure TMainForm.UpdateEEWItems(Rec: PEEWRec);
begin
  if Rec <> nil then
    try
      StringGrid1.Cells[1, 0] := FormatDateTime('yyyy-mm-dd hh:nn:ss', Rec.ReportTime);
      StringGrid1.Cells[1, 1] := Rec.ReportID;
      StringGrid1.Cells[1, 2] := Rec.ReportNo.ToString;
      StringGrid1.Cells[1, 3] := BooleanStr[Rec.IsCancel];
      StringGrid1.Cells[1, 4] := BooleanStr[Rec.IsAlert];
      StringGrid1.Cells[1, 5] := BooleanStr[Rec.IsFinal];
      StringGrid1.Cells[1, 6] := FormatDateTime('yyyy-mm-dd hh:nn:ss', Rec.OriginTIme);
      StringGrid1.Cells[1, 7] := Rec.EpicenterName;
      StringGrid1.Cells[1, 8] := Rec.EpicenterF.Y.ToString(TFloatFormat.ffFixed, 7, 1) + 'N ' +
                                  Rec.EpicenterF.X.ToString(TFloatFormat.ffFixed, 7, 1) + 'E';
      StringGrid1.Cells[1, 9] := Rec.Epicenter.X.ToString + ', ' + Rec.Epicenter.Y.ToString;
      StringGrid1.Cells[1, 10] := Rec.Depth;
      // Magnitude
      StringGrid1.Cells[1, 11] := Rec.Magnitude.ToString(TFloatFormat.ffFixed, 7, 1);
      Edit25.Text := StringGrid1.Cells[1, 11];
      if InRange(Rec.Magnitude, 0, 10) then
        Rectangle23.Fill.Color := MagnitudeColor[Round(Rec.Magnitude)]
      else
        Rectangle23.Fill.Color := TAlphaColorRec.White;
      // max int
      StringGrid1.Cells[1, 12] := Rec.MaxShindo;
      Edit26.Text := Rec.MaxShindo;
      // aleter 2023-07-25
      SetShindoScale(Image3, JmaIntToScale(Rec.MaxShindo));
    except
      on e: exception do
        AddToLog('TMainForm.UpdateEEWItems', e.Message);
    end;
end;

// ً}nk񃂁[hIUIZbg
procedure TMainForm.ResetEEWDetails;
begin
    StringGrid1.Cells[1, 0] := '';
    StringGrid1.Cells[1, 1] := '';
    StringGrid1.Cells[1, 2] := '';
    StringGrid1.Cells[1, 3] := '';
    StringGrid1.Cells[1, 4] := '';
    StringGrid1.Cells[1, 5] := '';
    StringGrid1.Cells[1, 6] := '';
    StringGrid1.Cells[1, 7] := '';
    StringGrid1.Cells[1, 8] := '';
    StringGrid1.Cells[1, 9] := '';
    StringGrid1.Cells[1, 10] := '';
    StringGrid1.Cells[1, 11] := '';
    StringGrid1.Cells[1, 12] := '';

    Edit25.Text := '';
    Edit26.Text := '';

    FWavesBitmap.Clear(0);

    Edit4.Text := '';
    Edit5.Text := '';
    Edit6.Text := '';
    Label29.Text := '';


    Rectangle5.Fill.Color := TAlphaColorRec.White;
    Rectangle23.Fill.Color := TAlphaColorRec.White;
    Rectangle5.Fill.Color := TAlphaColorRec.White;
    Image2.Bitmap := nil;
    Image3.Bitmap := nil;
    Image5.Bitmap := nil;

    EEW_Rec := System.Default(TEEWRec);
    FEqID := '';

    // n}ʒuZbg   add 2023-07-25
    MapDrawRect := TMapDrawRect.mrRightTop;
    SetUIOnImageBase;

end;

// u}Oj`[hvƁuőkxv̐FύX
procedure TMainForm.StringGrid1DrawColumnCell(Sender: TObject;
  const Canvas: TCanvas; const Column: TColumn; const Bounds: TRectF;
  const Row: Integer; const Value: TValue; const State: TGridDrawStates);
begin
  if (Value.ToString <> '(empty)') and (Column = StringColumn2) then begin
    try
      if Row = 11 then begin         // }Oj`[h
        var Mag: integer;
        Mag := Round(TryStrToSingle(Value.ToString));
        if InRange(Mag, 0, 10) then begin
          Canvas.Fill.Color := TAlphaColorRec.White;
          Canvas.FillRect(Bounds, 1.0);
          Canvas.Fill.Color := MagnitudeColor[Mag];
          Canvas.Font.Style := [TFontStyle.fsBold];
          Canvas.FillText(Bounds, Value.ToString, false, 1.0, [], TTextAlign.Leading, TTextAlign.Center);
        end;
      end else if (Row = 12) and (Value.ToString <> 's') then begin   // őkx
        Canvas.Fill.Color := TAlphaColorRec.White;
        Canvas.FillRect(Bounds, 1.0);
        var BackColor: TAlphaColorRec;
        BackColor.Color := GetColorByJmaInt(Value.ToString);
        Canvas.Fill.Color := BackColor.Color;
        var ARect: TRectF := Bounds;
        ARect.Width := 40;
        Canvas.FillRect(ARect, 1.0);  // wi
        Canvas.Fill.Color := TextColorWB[((BackColor.R * 299) + (BackColor.G * 587) + (BackColor.B * 114)) / 1000 < 128];
        Canvas.FillText(ARect, Value.ToString, false, 1.0, [], TTextAlign.Center);
      end;
    except

    end;
  end;
end;

// J̃oOWindowsŃXgwb_wiF̃X^CKpȂ̂
procedure TMainForm.StringGrid1DrawColumnHeader(Sender: TObject;
  const Canvas: TCanvas; const Column: TColumn; const Bounds: TRectF);
var
   ARect : TRectF;
begin
    ARect := Bounds;
    Canvas.Fill.Kind := TBrushKind.Solid;
    Canvas.Fill.Color := TAlphaColorRec.Dimgray;
    Canvas.FillRect(ARect, 1.0);
    ARect.Inflate(0, 0, -0.25, -0.25);
    Canvas.Fill.Color := TAlphaColorRec.Whitesmoke;
    Canvas.FillRect(ARect, 1.0);
    Canvas.Fill.Color := TAlphaColors.Black;
    {$IFDEF ANDROID}
    Canvas.Font.Size := 12; // * (Self.ClientWidth / 360);
    {$ENDIF}
    // Canvas.Font.Style := [TFontStyle.fsBold];
    Canvas.FillText(Bounds, StringGrid1.ColumnByIndex(Column.Index).Header, False, 1.0, [],
      TTextAlign.Center, TTextAlign.Center);

end;

// ݒɂĐkxF擾
function TMainForm.GetShindoColor(AScale: integer; AColor: TAlphaColor): TAlphaColor;
begin
  // kj^gpɂukj^FvȊONG
  if RadioButton4.IsChecked then
    result := GetJmaIntColorByScale(AScale, false)  // CےkxKF
  else if RadioButton5.IsChecked then
    result := GetJmaIntColorByScale(AScale, true)   // CےkxKF ~
  else
    result := AColor;                               // kj^̃XP[F

end;

// ݒɂĐkxJ[XP[Zbg
procedure TMainForm.SetShindoScale(Image: TImage; Scale: integer);
var
  ABitmap: TBitmap;
  ARect: TRect;
  APoint: single;
  Points: TPolygon;
begin
  ABitmap := TBitmap.Create(FJmaScale.Width,
                            Round(FJmaScale.Width * ((Image.Height - 6) / Image.Width)));
  try
    if ABitmap.Canvas.BeginScene then
      try
        ABitmap.Canvas.Clear(0);
        ARect := FJmaScale.Bounds;
        ARect.Offset(0, ABitmap.Height - FJmaScale.Height);
        // kj^gpɂukj^FvȊONG
        if RadioButton4.IsChecked then
          ABitmap.Canvas.DrawBitmap(FJmaScale, FJmaScale.Bounds, ARect, 1.0)
        else if RadioButton5.IsChecked then
          ABitmap.Canvas.DrawBitmap(FJmaScaleGrad, FJmaScaleGrad.Bounds, ARect, 1.0)
        else
          ABitmap.Canvas.DrawBitmap(FKyoshinScale, FKyoshinScale.Bounds, ARect, 1.0);
        ABitmap.Canvas.Fill.Color := TAlphaColorRec.Black;
        APoint := Scale * 4 + 3;
        SetLength(Points, 4);
        Points[0] := TPointF.Create(APoint - 8, 0);
        Points[1] := TPointF.Create(APoint + 8, 0);
        Points[2] := TPointF.Create(APoint, 12);
        Points[3] := TPointF.Create(APoint - 8, 0);
        ABitmap.Canvas.FillPolygon(Points, 1.0);
      finally
        ABitmap.Canvas.EndScene;
      end;
    Image.Bitmap.Assign(ABitmap);
  finally
    ABitmap.Free;
  end;

end;

// u݂̐kxvXg̍XV
procedure TMainForm.UpdateShindoList(List: TList; Count: integer; AScale: integer; AColor: TAlphaColor);
var
  Item: TListviewItem;
  ABitmap: TBitmap;
  Rec: PAreaRec;
  Text: string;
  NRec: TNameListRec;
begin
  if Count > 0 then begin
    ShindoListBase.Visible := true;
    Listview1.Items.BeginUpdate;
    try
      try
        Listview1.Items.Clear;
        for var i := 0 to 3 do begin
          Rec := List.Items[i];
          if Rec.Scale >= MinShindoScale then begin
            Item := Listview1.Items.Add;
            Item.Data['Text2'] := Rec.Name;
            Text := '';
            if (Rec.NameList <> nil) and (Rec.NameList.Count > 0) then
              for NRec in Rec.NameList do
                Text := Text + NRec.Name + ' ';
            Item.Data['Text1'] := Trim(Text);
            // Image 24pxDPIɔ2{
            ABitmap := TBitmap.Create(48, 48);
            try
              if ABitmap.Canvas.BeginScene then begin
                try
                  ABitmap.Canvas.Fill.Color := GetShindoColor(AScale, AColor);
                  ABitmap.Canvas.FillRect(ABitmap.Bounds, 1.0);
                  ABitmap.Canvas.Stroke.Thickness := 2;
                  ABitmap.Canvas.Stroke.Color := $FFD4D4D4; //TAlphaColorRec.Snow;
                  ABitmap.Canvas.DrawRect(ABitmap.Bounds, 1.0);
                  // kj^gp̂ߐkxl̓ftHgł͕\Ȃ
                  if Switch4.IsChecked then begin
                    ABitmap.Canvas.Font.Size := 32;
                    ABitmap.Canvas.Font.Family := 'Arial Black';
                    {$IFDEF ANDROID}
                    ABitmap.Canvas.Font.Style := [TFontStyle.fsBold];
                    {$ENDIF}
                    // wiFɍFi^jI  https://www.w3.org/TR/AERT/#color-contrast
                    ABitmap.Canvas.Fill.Color := GetTextColor(Rec.Color);
                    ABitmap.Canvas.FillText(ABitmap.Bounds, GetShindoStrByScale(Rec.Scale), false, 1.0, [],
                                 TTextAlign.Center, TTextAlign.Center);
                  end;
                finally
                  ABitmap.Canvas.EndScene;
                end;
              end;
              Item.Data['Image3'] := ABitmap;
            finally
              ABitmap.Free;
            end;
          end else
            Break;
        end;
        FLastListShindoTime := Clock;
      except
        on e: exception do
          AddToLog('TMainForm.UpdateShindoList', e.Message);
      end;
    finally
      Listview1.Items.EndUpdate;
    end;

    // kxXg̈ʒu  add 2023-07-23
    if (MapDrawRect = TMapDrawRect.mrLeftBottom) or (MapDrawRect = TMapDrawRect.mrRightBottom) then
      ShindoListBase.Position.Y := ImageBase.Height - (Rectangle20.Height + 32 * Listview1.Items.Count);

  end else
    ShindoListBase.Visible := false;

  try
    // ݒn̐kx
    if InRange(AScale, 0, 99) then begin
      var TheColor := GetShindoColor(AScale, AColor);
      Rectangle4.Fill.Color := TheColor;
      SetShindoScale(Image1, AScale);

      Rectangle6.Fill.Color := TheColor;
      SetShindoScale(Image4, AScale);
      if Switch4.IsChecked then begin
        Label23.FontColor := GetTextColor(TheColor);
        Label23.Text := GetJmaIntByScale(AScale);
        Label26.FontColor := Label23.FontColor;
        Label26.Text := GetJmaIntByScale(AScale);
      end else begin
        Label23.Text := '';
        Label26.Text := '';
      end;
    end else begin
      Rectangle4.Fill.Color := $FFE0E0E0;
      Image1.Bitmap := nil;
      Rectangle6.Fill.Color := $FFE0E0E0;
      Image4.Bitmap := nil;
      Label23.Text := '';
      Label26.Text := '';
    end;
  except
    on e: exception do
      AddToLog('TMainForm.UpdateShindoList_1', e.Message);
  end;

end;

// Ăϑ_͈
procedure TMainForm.KyoshinReacted(List: TList<TRect>);
begin
  if (List <> nil) and (List.Count > 0) then begin
    if FInfoBitmap.Canvas.BeginScene then       // MapPosToExMapPos
      try
        FInfoBitmap.Canvas.Clear(TAlphaColorRec.Null);
        FInfoBitmap.Canvas.Stroke.Color := TAlphaColorRec.Red;
        var TheRect: TRect;
        for var ARect in List do begin
          TheRect.TopLeft := MapPosToExMapPos(ARect.TopLeft);
          TheRect.BottomRight := MapPosToExMapPos(ARect.BottomRight);
          FInfoBitmap.Canvas.DrawRect(TheRect, 1.0);
        end;
      finally
        FInfoBitmap.Canvas.EndScene;
      end;

    FInfoBitmapEnabled := true;
    UpDateMainImage;

  end else
    FInfoBitmapEnabled := false;
end;

// ݒn̗\zkx̃Zbg
procedure TMainForm.UpdateEstShindo(AScale: integer; AColor: TAlphaColor);
begin
  if AScale >= 0 then begin
    Rectangle5.Fill.Color := GetShindoColor(AScale, AColor);
    SetShindoScale(Image2, AScale);
    if Switch4.IsChecked then begin
      Label29.FontColor := GetTextColor(AColor);
      Label29.Text := GetJmaIntByScale(AScale);
    end else
      Label29.Text := '';
  end else begin
    Rectangle5.Fill.Color := $FFE0E0E0;
    Label29.Text := '';
    Image2.Bitmap := nil;
  end;

end;

// PSg̕`ƓBԂ̍XV
procedure TMainForm.UpdatePSWaves(Rec: PPsWavesInfo);
begin
  if EEWState and (Rec <> nil) then begin
    // k
    Edit6.Text := Rec.EpicenterToCurrPointF.ToString + ' km';
    // Sga
    if Rec.SDistance > 0 then
      Edit4.Text := Rec.SDistance.ToString + ' km';
    // Sǧݒn܂ł̋
    var DistanceToCP := Rec.EpicenterToCurrPointF - Rec.SDistance;
    if DistanceToCP > 0 then begin
      Edit5.Text := DistanceToCP.ToString + ' km';
      if DistanceToCP > 120 then begin           // > 30 sec
        Edit5.FontColor := TAlphaColorRec.Black;
        Edit5.Font.Style := [];
      end else if DistanceToCP > 40 then begin   // 30 .. 10 sec
        Edit5.FontColor := TAlphaColorRec.Green;
        Edit5.Font.Style := [TFontStyle.fsBold];
      end else begin                             // < 10 sec
        Edit5.FontColor := TAlphaColorRec.Red;
        Edit5.Font.Style := [TFontStyle.fsBold];
      end;
    end else begin
      Edit5.Text := 'B';
      Edit5.FontColor := TAlphaColorRec.Black;
      Edit5.Font.Style := [TFontStyle.fsBold];
    end;

    if AppClosing then Exit;

    // PSg̕`
    DrawSPWave(Rec);

    if AppClosing then Exit;

    // kj^EEBhEXV
    UpDateMainImage;

    // add 2023-08-01
    MakePSWavesImage(Rec);

  end;
end;

// PSg̕`
procedure TMainForm.DrawSPWave(Rec: PPsWavesInfo);
  // ~̃Of[V`
  function GetGradientBitmap(AWidth, AHeight: integer; AColor: TAlphaColor; AStart, AEnd: Cardinal): TBitmap;
  const
    MinAlpha = 64;
  var
    BitmapData: TBitmapData;
    X, Y: integer;
    Line: PAlphaColorArray;
    PColor: TAlphaColorRec;
  begin
    result := TBitmap.Create(AWidth, AHeight);
    // AColorF̉~AlphalAStartiOjAEndiSj܂ł̃Of[Vŕ`
    result.Canvas.BeginScene;
    try
      result.Canvas.Clear(0);
      result.Canvas.Fill.Kind := TBrushKind.Gradient;
      result.Canvas.Fill.Gradient.Style := TGradientStyle.Radial;
      PColor.Color := AColor;
      PColor.A := AStart;
      result.Canvas.Fill.Gradient.Color := PColor.Color;
      PColor.A := AEnd;
      result.Canvas.Fill.Gradient.Color1 := PColor.Color;
      result.Canvas.FillEllipse(TRect.Create(Point(0, 0), AWidth, AHeight), 1.0);
    finally
      result.Canvas.EndScene;
    end;
    // S߂𓧖ɏC
    if result.Map(TMapAccess.ReadWrite, BitmapData) then
      try
        for Y := 0 to result.Height - 1 do begin
          Line := BitmapData.GetScanline(Y);
          for X := 0 to result.Width - 1 do begin
            PColor.Color := Line^[X];
            if PColor.A > 0 then begin
              if PColor.A >= MinAlpha then
                PColor.A := PColor.A - MinAlpha
              else
                PColor.A := 0;
              //PColor.A := Max(0, PColor.A - MinAlpha);
              PColor.A := Round(PColor.A * 3);
              //PColor.A := Min(255, Round(PColor.A * AStart / MinAlpha));
              Line^[X] := PColor.Color;
            end;
          end;
        end;
      finally
        result.Unmap(BitmapData);
      end;
  end;
const
  EpicenterRadius = 12;
var
  ARect: TRect;
  ABitmap: TBitmap;
begin
  if Rec = nil then
    exit;

  FWavesBitmap.Canvas.BeginScene;
  try
    try
      FWavesBitmap.Canvas.Clear(0);

      if InRange(Rec.TravelTime, 10, 180) then begin
        FWavesBitmap.Canvas.Fill.Kind := TBrushKind.Solid;

        // PWave
        if InRange(Rec.PRadius, 10, 600) then begin  // Pg̕`攼a͍ő600px܂
          ARect := TRect.Create(Rec.Epicenter.X - Rec.PRadius, Rec.Epicenter.Y - Rec.PRadius,
                         Rec.Epicenter.X + Rec.PRadius, Rec.Epicenter.Y + Rec.PRadius);
          if FWavesBitmap.Bounds.IntersectsWith(ARect) then begin
            // Of[Vt~Bitmapō쐬
            ABitmap := GetGradientBitmap(ARect.Width, ARect.Height, TAlphaColorRec.Blue, 96, 0);
            if ABitmap <> nil then begin
              // ~`悳ꂽBitmapCBitmapɕ`
              FWavesBitmap.Canvas.DrawBitmap(ABitmap, ABitmap.Bounds, ARect, 1.0);
              ABitmap.Free;
            end;
          end;
        end;

        if AppClosing then Exit;

        // SWave
        if InRange(Rec.SRadius, 10, 400) then begin  // Sg̕`攼a͍ő400px܂
          ARect := TRect.Create(Rec.Epicenter.X - Rec.SRadius, Rec.Epicenter.Y - Rec.SRadius,
                         Rec.Epicenter.X + Rec.SRadius, Rec.Epicenter.Y + Rec.SRadius);
          if FWavesBitmap.Bounds.IntersectsWith(ARect) then begin
            ABitmap := GetGradientBitmap(ARect.Width, ARect.Height, TAlphaColorRec.Red, 96, 0);
            if ABitmap <> nil then begin
              FWavesBitmap.Canvas.DrawBitmap(ABitmap, ABitmap.Bounds, ARect, 1.0);
              ABitmap.Free;
            end;
          end;
        end;

        if AppClosing then Exit;

        // epicenter
        if not Rec.Epicenter.IsZero then begin
          ARect := TRect.Create(Rec.Epicenter.X - EpicenterRadius, Rec.Epicenter.Y - EpicenterRadius,
                                Rec.Epicenter.X + EpicenterRadius, Rec.Epicenter.Y + EpicenterRadius);
          if FWavesBitmap.Bounds.IntersectsWith(ARect) then
            // ImageListIndexw肵Đk}[NCBitmapɕ`
            ImageList1.Draw(FWavesBitmap.Canvas, ARect, 3, 1.0);
        end;

      end;
    except
      on e: exception do
        AddToLog(ltError, 'TMainForm.DrawSPWave', e.Message);
    end;
  finally
    FWavesBitmap.Canvas.EndScene;
  end;

end;

// temp
procedure TMainForm.Button1Click(Sender: TObject);
begin
  {var EpicenterF := TPointF.Create(142.9,41.1);
  var Epicenter := Get_Ex_MapPos(EpicenterF);
  var CurrentF := TPointF.Create(139.69, 35.7); // 349; Y:259    (X:139.69; Y:35.7);
  var Current := Get_Ex_MapPos(CurrentF);
  var CurrentDistance := Epicenter.Distance(Current);
  var CurrentDistanceF := GetHubenyDistance(EpicenterF, CurrentF);

  const Radius = 100;

  ShowMessage(CurrentDistanceF.ToString + ', ' +
              Round(CurrentDistanceF * (Radius / CurrentDistance)).ToString);}


{  var Epicenter := TPoint.Create(200, 200);
  var EpicenterF: TPointF;
  var APoint: TPoint;
  var ApointF: TPointF;
  var Distance: integer;
  var Text: string := '';
  EpicenterF := Get_Ex_LonLan(Epicenter);

  APoint := TPoint.Create(200, 100);
  APointF := Get_Ex_LonLan(APoint);
  Text := Text + Round(GetHubenyDistance(EpicenterF, APointF)).ToString + ', ';

  APoint := TPoint.Create(100, 200);
  APointF := Get_Ex_LonLan(APoint);
  Text := Text + Round(GetHubenyDistance(EpicenterF, APointF)).ToString + ', ';




  SHowMessage(Text); }




{  var ABitmap := TBitmap.Create(100, 6);
  var BitmapData: TBitmapData;
  try
    ABitmap.Map(TMapAccess.Write, BitmapData);
    for var x := 0 to 99 do begin
      var AColor := GetJmaIntColorByScale(x, true);
      for var y := 0 to 5 do
        BitmapData.SetPixel(x, y, AColor);
    end;

    ABitmap.UnMap(BitmapData);
    ABitmap.SaveToFile(AppDir + PathDelim + 'JmaIntColorScale_2.png');
  finally
    ABitmap.Free;
  end;}

  var Rec: PPsWavesInfo;
  New(Rec);
  try
    Rec.EpicenterToCurrPointF := 300;
    Rec.PDistance := 400;
    Rec.SDistance := 250;
    Edit5.TextSettings.FontColor := TAlphaColorRec.red;


    MakePSWavesImage(Rec);
  finally
    Dispose(Rec);
  end;

  {var SList := TstringList.Create;
  try
    for var i := 0 to 99 do begin
      SList.Add(
        IntToStr(ColorToIndexScale(KyoshinAlphaColors[i])) + ':' +
        ColorToScale(KyoshinAlphaColors[i]).ToString(TFloatFormat.ffFixed, 7, 2));


    end;
    SList.SaveToFile('ColorCnv.txt', TEncoding.UTF8);
  finally
    SList.Free;
  end;}
end;

procedure TMainForm.MakePSWavesImage(Rec: PPsWavesInfo);
var
  ABitmap: TBitmap;
  ARect: TRectF;
  P: integer;
begin
  // Image5 260 * 32
  ABitmap := TBitmap.Create(520, 64);
  try
    try
      if ABitmap.Canvas.BeginScene then begin
        try
          ABitmap.Canvas.Clear(TAlphaColorRec.White);
          // Background between S wave and CurrentPoint
          if Edit5.TextSettings.FontColor <> TAlphaColorRec.Black then begin
            ABitmap.Canvas.Fill.Color := Edit5.TextSettings.FontColor;
            ARect := TRectF.Create(Rec.SDistance + 16, 0, Rec.EpicenterToCurrPointF + 16, 46);
            ABitmap.Canvas.FillRect(ARect, 0.2);
          end;

          // km scale
          ABitmap.Canvas.Fill.Color := TAlphaColorRec.Darkgray;
          ABitmap.Canvas.Font.Size := 20;
          ARect := TRectF.Create(0, 0, 100, 100);
          ABitmap.Canvas.MeasureText(ARect, '900', false, [], TTextAlign.Leading, TTextAlign.Leading);
          ARect.Offset(16 - ARect.Width / 2, 20);
          for var i := 0 to 5 do begin
            if i < 5 then begin
              ABitmap.Canvas.FillText(ARect, (i*100).tostring, false, 1.0, [], TTextAlign.Center);
              ARect.Offset(100, 0);
            end else begin
              ARect := TRectF.Create(0, 0, 100, 100);
              ABitmap.Canvas.MeasureText(ARect, '(km)', false, [], TTextAlign.Leading, TTextAlign.Leading);
              ARect := TRectF.Create(ABitmap.Width - ARect.Width - 4, 20, ABitmap.Width - 4, 20 + ARect.Height);
              ABitmap.Canvas.FillText(ARect, '(km)', false, 1.0, [], TTextAlign.Leading);
            end;
          end;
          // Current point
          if Rec.EpicenterToCurrPointF < 500 then begin
            ARect := TRect.Create(Rec.EpicenterToCurrPointF - 18 + 16, 2, Rec.EpicenterToCurrPointF + 18 + 16, 38);
            ImageList1.Draw(ABitmap.Canvas, ARect, 2, 1.0);
          end;
          // PWave
          P :=  EnsureRange(Rec.PDistance, 0, 500);
          ARect := TRect.Create(16, 56, P + 16, 60);
          ABitmap.Canvas.Fill.Color := TAlphaColorRec.Blue;
          ABitmap.Canvas.FillRect(ARect, 1.0);
          if Rec.PDistance < 500 then begin
            ARect := TRect.Create(Rec.PDistance - 18 + 16, 2, Rec.PDistance + 18 + 16, 38);
            ImageList1.Draw(ABitmap.Canvas, ARect, 13, 1.0);
          end;
          // SWave
          P :=  EnsureRange(Rec.SDistance, 0, 500);
          ARect := TRect.Create(16, 50, P + 16, 54);
          ABitmap.Canvas.Fill.Color := TAlphaColorRec.Red;
          ABitmap.Canvas.FillRect(ARect, 1.0);
          if Rec.SDistance < 500 then begin
            ARect := TRect.Create(Rec.SDistance - 18 + 16, 2, Rec.SDistance + 18 + 16, 38);
            ImageList1.Draw(ABitmap.Canvas, ARect, 14, 1.0);
          end;
        finally
          ABitmap.Canvas.EndScene;
        end;
      end;
      Image5.Bitmap.Assign(ABitmap);
    except
      on e: exception do
        AddToLog(ltError, 'TMainForm.MakePSWavesImage', e.Message);
    end;
  finally
    ABitmap.Free;
  end;
end;

//
// c[
//

// [0150km܂10kmPʂ̃f[^̂ݒoȈՑ\ǧvZ
// \gPgSǧvZ̓c[݂̂ŁA{AṽCł͎gpĂȂ
procedure TMainForm.Button4Click(Sender: TObject);
var
  PWaveDistance, SWaveDistance: single;
begin
  TThread.CreateAnonymousThread(procedure
  begin
    PWaveDistance := 0;
    SWaveDistance := 0;
    SecondToDistance(Round(SpinBox8.Value), Round(SpinBox7.Value),
                     PWaveDistance, SWaveDistance);

    TThread.Synchronize(TThread.CurrentThread,
    procedure
    begin
      Edit14.Text := Round(PWaveDistance).ToString + ' km';
      Edit15.Text := Round(SWaveDistance).ToString + ' km';
    end);
  end).Start;

end;

// ݒn̒nՑ擾
procedure TMainForm.Button5Click(Sender: TObject);
begin
  TThread.CreateAnonymousThread(procedure
  var
    Text: string;
  begin
    Text := GetMeshInfo(CurrentPointF, 3);

    TThread.Synchronize(TThread.CurrentThread,
    procedure
    begin
      NumberBox7.Value := TryStrToSingle(Text);
    end);
  end).Start;
end;

// ݒn
procedure TMainForm.Button7Click(Sender: TObject);
begin
  NumberBox4.Value := CurrentPointF.Y;
  NumberBox3.Value := CurrentPointF.X;
end;

// k n}̃NbNWoxܓxŎ擾
procedure TMainForm.PaintBox1Click(Sender: TObject);
begin
  var MousePoint := MapPosToExMapPos(FMousePos);
  NumberBox8.Value := MousePoint.X;
  NumberBox9.Value := MousePoint.Y;

  var ClickPoint := Get_Ex_LonLan(MousePoint);
  NumberBox1.Value := ClickPoint.Y;
  NumberBox2.Value := ClickPoint.X;
  Edit12.Text := LatLonToStr(ClickPoint);

end;

procedure TMainForm.PaintBox1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Single);
begin
  FShiftState := Shift;
  FMousePos := Point(Round(X), Round(Y));
end;

// \kx̌vZ
// vZɂ\zkx̎擾͌vZ̓c[݂̂ŁA{AṽCł͎gpĂȂ
procedure TMainForm.Button6Click(Sender: TObject);
var
  EstShindo: single;
  Epicenter, CurrentPoint: TPointF;
begin
  try
    EPicenter := TPointF.Create(NumberBox2.Value, NumberBox1.Value);
    CurrentPoint := TPointF.Create(NumberBox3.Value, NumberBox4.Value);

    EstShindo := GetEstShindo(EPicenter, Round(NumberBox5.Value), Round(NumberBox6.Value),
                              CurrentPoint, NumberBox7.Value);
    Edit19.Text := EstShindo.ToString(TFloatFormat.ffFixed, 2, 1);
  except
    on e: exception do
      AddToLog(ltError, 'TMainForm.Button6Click', e.Message);
  end;
end;

procedure TMainForm.Button3Click(Sender: TObject);
begin
  Edit12.Text := LatLonToStr(Get_Ex_LonLan(Point(Round(NumberBox8.Value), Round(NumberBox9.Value))));
end;

procedure TMainForm.Button9Click(Sender: TObject);
begin
  var APoint := Get_Ex_MapPos(TPointF.Create(NumberBox10.Value, NumberBox11.Value));
  Edit16.Text := APoint.X.ToString + ', ' + APoint.Y.ToString;
end;


end.
